<?php

/*
* $Id: dimensions.php
* $Loc: /admin/
*
* Name: products_meassures
* Version: 2.0.0
* Release Date: 09/23/2022
* Author: Daniel @Kofod95
* 	 phoenixcart.org - Kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2022: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/



  require 'includes/application_top.php';

  $link = $Admin->link()->retain_query_except(['dID', 'action']);
  const DEFAULT_ARRAY = [['id' => 'mm', 'text' => 'milimeter'], ['id' => 'cm', 'text' => 'centimeter'], ['id' => 'm', 'text' => 'meter'], ['id' => 'in', 'text' => 'inches'], ['id' => 'ft', 'text' => 'foot'], ['id' => 'yd', 'text' => 'yard'], ['id' => 'misc', 'text' => 'other']];
 
  require 'includes/segments/process_action.php';

  $table_definition = [
    'columns' => [
      [
        'name' => TABLE_HEADING_DIMENSIONS,
        'is_heading' => true,
        'function' => function ($row) {
          return $row['dimensions_name'];
        },
      ],
      [
        'name' => TABLE_HEADING_DEFAULT,
        'is_heading' => true,
        'function' => function ($row) {
          return $row['dimensions_default'];
        },
      ],
	  [
        'name' => TABLE_HEADING_CONVERTS,
        'is_heading' => true,
        'function' => function ($row) {
          return $row['dimensions_converts_to'];
        },
      ],	  
      [
        'name' => TABLE_HEADING_SORT,
        'is_heading' => true,
        'function' => function ($row) {
          return $row['dimensions_sort_order'];
        },
      ],	  
      [
        'name' => TABLE_HEADING_ACTION,
        'class' => 'text-right',
        'function' => function ($row) {
          return (isset($row['info']->dimensions_id) && ($row['dimensions_id'] == $row['info']->dimensions_id) )
               ? '<i class="fas fa-chevron-circle-right text-info"></i>'
               : '<a href="' . $row['onclick'] . '"><i class="fas fa-info-circle text-muted"></i></a>';
        },
      ],
    ],
    'count_text' => TEXT_DISPLAY_NUMBER_OF_DIMENSIONS,
    'page' => $_GET['page'] ?? null,
    'web_id' => 'dID',
    'db_id' => 'dimensions_id',
    'rows_per_page' => MAX_DISPLAY_SEARCH_RESULTS,
    'sql' => "SELECT * FROM dimensions d LEFT JOIN dimensions_info di ON d.dimensions_id = di.dimensions_id WHERE di.languages_id = " . (int)$_SESSION['languages_id'] . " ORDER BY dimensions_sort_order",
  ];

  $table_definition['function'] = function (&$row) use (&$table_definition) {
    $row['onclick'] = $GLOBALS['link']->set_parameter(
      'dID', $row['dimensions_id']);

    if (!isset($table_definition['info'])
      && (!isset($_GET['dID']) || ($_GET['dID'] == $row['dimensions_id']))
      && !Text::is_prefixed_by($GLOBALS['action'], 'new'))
    {
      //$row = array_merge($row, $GLOBALS['db']->query("SELECT COUNT(*) AS products_count FROM products WHERE products_location = " . (int)$row['locations_id'])->fetch_assoc());

      $table_definition['info'] = new objectInfo($row);
      $row['info'] = &$table_definition['info'];

      $row['css'] = ' class="table-active"';
      $row['onclick'] = (clone $row['onclick'])->set_parameter('action', 'edit');
    } else {
      $row['css'] = '';
    }
  };

  $table_definition['split'] = new Paginator($table_definition);

  require 'includes/template_top.php';
?>

  <div class="row">
    <div class="col">
      <h1 class="display-4 mb-2"><?= HEADING_TITLE; ?></h1>
    </div>
    <div class="col text-right align-self-center">
      <?=
        empty($action)
      ? $Admin->button(BUTTON_INSERT_NEW_DIMENSION, 'fas fa-id-card', 'btn-danger', $Admin->link('dimensions.php', ['action' => 'new']))
      : $Admin->button(IMAGE_BACK, 'fas fa-angle-left', 'btn-light', $link)
      ?>
    </div>
  </div>

<?php
  $table_definition['split']->display_table();

  require 'includes/template_bottom.php';
  require 'includes/application_bottom.php';
?>
