<?php

/*
* $Id: edit.php
* $Loc: /admin/includes/actions/dimensions/infoboxes/
*
* Name: products_meassures
* Version: 2.0.0
* Release Date: 09/23/2022
* Author: Daniel @Kofod95
* 	 phoenixcart.org - Kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2022: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/



  $dInfo = &$table_definition['info'];
  $heading = TEXT_HEADING_EDIT_DIMENSION . ' <small>' . TEXT_EDIT_INTRO . '</small>';
  $link = $GLOBALS['link']->set_parameter('dID', (int)$dInfo->dimensions_id);

  $converts_array = DEFAULT_ARRAY;
  array_splice($converts_array, -1);
  $converts = $converts_array;

  $contents = ['form' => new Form('dimensions', (clone $link)->set_parameter('action', 'save'), 'post', ['enctype' => 'multipart/form-data'])];
  $contents[] = ['text' => TEXT_EDIT_INTRO];
  $contents[] = ['text' => TEXT_DIMENSIONS_DEFAULT . '<br>' . new Select('dimensions_default', DEFAULT_ARRAY, ['value' => $dInfo->dimensions_default])];
  $contents[] = ['text' => TEXT_DIMENSIONS_CONVERTS_TO . '<br>' . new Select('dimensions_converts_to', $converts, ['value' => $dInfo->dimensions_converts_to])];
  $contents[] = ['text' => TEXT_DIMENSIONS_ROUND . '<br>' . new Select('dimensions_round', [['id' => '0', 'text' => 'False'], ['id' => '1', 'text' => 'True']], ['value' => $dInfo->dimensions_round])];  
  $contents[] = ['text' => TEXT_DIMENSIONS_SORT_ORDER . '<br>' . new Input('dimensions_sort_order', ['value' => $dInfo->dimensions_sort_order])];


  $dimension_name_string = $dimension_prepend_string = $dimension_append_string = '';
  foreach (language::load_all() as $l) {
    $dimension = $GLOBALS['db']->query(sprintf(<<<'EOSQL'
SELECT dimensions_name, dimensions_prepend, dimensions_append
 FROM dimensions_info
 WHERE dimensions_id = %d AND languages_id = %d
EOSQL
      , (int)$dInfo->dimensions_id, (int)$l['id']))->fetch_assoc();
    $flag_image = $GLOBALS['Admin']->catalog_image("includes/languages/{$l['directory']}/images/{$l['image']}", [], $l['name']);
    $dimension_name_string .= '<div class="input-group"><div class="input-group-prepend"><span class="input-group-text">' . $flag_image . '</span></div>' . new Input("dimensions_name[{$l['id']}]", ['value' => $dimension['dimensions_name']]) . '</div>';
    $dimension_prepend_string .= '<div class="input-group"><div class="input-group-prepend"><span class="input-group-text">' . $flag_image . '</span></div>' . new Input("dimensions_prepend[{$l['id']}]", ['value' => $dimension['dimensions_prepend']]) . '</div>';
    $dimension_append_string .= '<div class="input-group"><div class="input-group-prepend"><span class="input-group-text">' . $flag_image . '</span></div>' . new Input("dimensions_append[{$l['id']}]", ['value' => $dimension['dimensions_append']]) . '</div>';
  }

  $contents[] = ['text' => TEXT_DIMENSIONS_NAME . $dimension_name_string];
  $contents[] = ['text' => TEXT_DIMENSIONS_PREPEND . $dimension_prepend_string];
  $contents[] = ['text' => TEXT_DIMENSIONS_APPEND . $dimension_append_string];
  $contents[] = [
    'class' => 'text-center',
    'text' => new Button(IMAGE_SAVE, 'fas fa-save', 'btn-success mr-2')
            . $GLOBALS['Admin']->button(IMAGE_CANCEL, 'fas fa-times', 'btn-light', $link),
  ];
