<?php

/*
* $Id: dimensions.php
* $Loc: /includes/hooks/admin/catalog/
*
* Name: products_meassures
* Version: 2.0.0
* Release Date: 09/23/2022
* Author: Daniel @Kofod95
* 	 phoenixcart.org - Kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2022: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/



class hook_admin_catalog_dimensions {

  public function listen_productTab() {  
    $tab_title = addslashes(DIMENSIONS_TITLE);
    $tab_link  = '#section_dimensions';
	
	$products_id = $_GET['pID'] ?? '0';

    $dimensions_input = '';

    $add_edit_intro = DIMENSIONS_INTRO;
    $add_edit_dimensions = DIMENSIONS_ADD_EDIT;
	
	$values_query = $GLOBALS['db']->fetch_all("SELECT * FROM dimensions_to_products WHERE products_id = " . (int)$products_id);
	if(!empty($values_query[0]['dimensions_value'])) {
	  foreach($values_query as $values){
		$dimension_value[$values['dimensions_id']] = $values['dimensions_value'];
	  }
	}

    $dimensions_query = $GLOBALS['db']->query("SELECT * FROM dimensions d LEFT JOIN dimensions_info di ON d.dimensions_id = di.dimensions_id WHERE di.languages_id = " . (int)$_SESSION['languages_id'] . " ORDER BY dimensions_sort_order");
    while ($dimensions = $dimensions_query->fetch_assoc()) {
      $dimensions_input .= '<label for="d_' . $dimensions['dimensions_id'] . '">' . $dimensions['dimensions_name'] . '</label>' . '&emsp;<small class="text-muted">' . DIMENSIONS_DEFAULT . $dimensions['dimensions_default'] . '&emsp;' . DIMENSIONS_PREPEND . $dimensions['dimensions_prepend'] . '&emsp;' . DIMENSIONS_APPEND . $dimensions['dimensions_append'] . '</small><br>';;	  
      $dimensions_input .= new Input('d_' . $dimensions['dimensions_id'], ['id' => 'd_' . $dimensions['dimensions_id'], 'value' => $dimension_value[$dimensions['dimensions_id']] ?? '']);
    }

    $output = <<<"EOD"
<script>
  $('#productTabs ul.nav.nav-tabs').append('<li class="nav-item"><a class="nav-link" data-toggle="tab" href="{$tab_link}" role="tab">{$tab_title}</a></li>');
</script>

<div class="tab-pane fade" id="section_dimensions" role="tabpanel">
  <div class="alert alert-info">
    {$add_edit_intro}
  </div>
  <table class="table table-sm">
    <tr>
      <th valign="top">{$add_edit_dimensions}</th>
      <td>{$dimensions_input}</td>
    </tr>
  </table>
</div>
EOD;

    return $output;
  }

  public function listen_productActionSave() {
    global $products_id;

    // master blaster
    $GLOBALS['db']->query("DELETE FROM dimensions_to_products WHERE products_id = '" . (int)$products_id . "'");
	$dimensions_query = $GLOBALS['db']->query("SELECT dimensions_id FROM dimensions");
	$dimensions_input = [];
    while($dimensions = $dimensions_query->fetch_assoc()){
	  if(!empty($_POST['d_' . $dimensions['dimensions_id']])) $dimensions_input[$dimensions['dimensions_id']] = $_POST['d_' . $dimensions['dimensions_id']];
	}
    if ( count((array)$dimensions_input) > 0 ) {
      foreach($dimensions_input as $k => $v) {
        $sql = ['products_id' => (int)$products_id, 'dimensions_id' => (int)$k, 'dimensions_value' => Text::input($v)];

        $GLOBALS['db']->perform('dimensions_to_products', $sql);
      }
    }
  }

  public function listen_updateProductAction() {
    $this->listen_productActionSave();
  }

   public function listen_insertProductAction() {
    $this->listen_productActionSave();
  }

}
