<?php

/*
* $Id: pi_dimensions.php
* $Loc: /includes/modules/pi/product_info/
*
* Name: products_meassures
* Version: 2.0.0
* Release Date: 09/23/2022
* Author: Daniel @Kofod95
* 	 phoenixcart.org - Kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2022: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/



  class pi_dimensions extends abstract_module {

    const CONFIG_KEY_BASE = 'PI_DIMENSIONS_';

    public $group = 'pi_modules_b';
    public $content_width;

    public function __construct() {
      parent::__construct();

      $this->group = basename(dirname(__FILE__));

      $this->description .= '<div class="alert alert-warning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';
      $this->description .= '<div class="alert alert-info">' . cm_pi_modular::display_layout() . '</div>';

      if ( $this->enabled ) {
        $this->group = 'pi_modules_' . strtolower(PI_DIMENSIONS_GROUP);
        $this->content_width = (int)PI_DIMENSIONS_CONTENT_WIDTH;
      }
    }

    public function getOutput() {
	  $dimensions_query = $GLOBALS['db']->query("SELECT * FROM dimensions d LEFT JOIN dimensions_info di ON d.dimensions_id = di.dimensions_id LEFT JOIN dimensions_to_products d2p on d.dimensions_id = d2p.dimensions_id WHERE di.languages_id = '" . (int)$_SESSION['languages_id'] . "' AND d2p.products_id = '" . (int)$GLOBALS['product']->get('id') . "' ORDER BY d.dimensions_sort_order");
		
      $products_weight = $GLOBALS['product']->get('weight');
      if (!Text::is_empty($products_weight)) {
		$weight['value'] = $products_weight;
		$weight['alt_value'] = 'N/A';
		$weight['append'] = PI_DIMENSIONS_WEIGHT;
		$weight['alt_append'] = 'N/A';
		switch(PI_DIMENSIONS_WEIGHT){
		  case 'g':
		    $weight['decimal'] = ',';
			$weight['separator'] = '.';
		    $weight['alt_value'] = $products_weight / 28.349523125;
			$weight['alt_append'] = 'oz';
			if($products_weight > 1000){
			  $weight['value'] = $products_weight / 1000;
			  $weight['append'] = 'kg';
			  $weight['alt_value'] = $products_weight / 453.59237;
			  $weight['alt_append'] = 'lb';
			}
		  break;
		  case 'kg':
		    $weight['decimal'] = ',';
			$weight['separator'] = '.';	  
		    $weight['alt_value'] = $products_weight / 0.45359237;
			$weight['alt_append'] = 'lb';
			if($products_weight < 1){
			  $weight['value'] = $products_weight * 1000;
			  $weight['append'] = 'g';
			  $weight['alt_value'] = $products_weight / 0.028349523125;
			  $weight['alt_append'] = 'oz';
			}		  
		  break;
		  case 'oz':
		    $weight['decimal'] = '.';
			$weight['separator'] = ',';	  
		    $weight['alt_value'] = $products_weight * 28.349523125;
			$weight['alt_append'] = 'g';
			if($products_weight > 32){
			  $weight['value'] = $products_weight / 16;
			  $weight['append'] = 'lb';
			  $weight['alt_value'] = $products_weight * 0.028349523125;
			  $weight['alt_append'] = 'kg';
			}		  
		  break;
		  case 'lb':
		    $weight['decimal'] = '.';
			$weight['separator'] = ',';  
		    $weight['alt_value'] = $products_weight / 28.349523125;
			$weight['alt_append'] = 'kg';
			if($products_weight < 2){
			  $weight['value'] = $products_weight * 16;
			  $weight['append'] = 'oz';
			  $weight['alt_value'] = $products_weight * 453.59237;
			  $weight['alt_append'] = 'g';
			}		  
		  break;
		  default:
		    $weight['decimal'] = ',';
			$weight['separator'] = '.';	  
		  break;
		}
	  }
	  
      if (!empty($dimensions_query)) {
        $tpl_data = ['group' => $this->group, 'file' => __FILE__];
        include 'includes/modules/block_template.php';
      }
    }

    protected function get_parameters() {
      return [
        'PI_DIMENSIONS_STATUS' => [
          'title' => 'Enable Dimensions',
          'value' => 'True',
          'desc' => 'Should this module be shown on the product info page?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'PI_DIMENSIONS_WEIGHT' => [
          'title' => 'Weight-unit',
          'value' => 'g',
          'desc' => 'What scale is used for the products weight?',
          'set_func' => "Config::select_one(['g', 'kg', 'oz', 'lb'], ",
        ],		
        'PI_DIMENSIONS_GROUP' => [
          'title' => 'Module Display',
          'value' => 'B',
          'desc' => 'Where should this module display on the product info page?',
          'set_func' => "Config::select_one(['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I'], ",
        ],
        'PI_DIMENSIONS_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '12',
          'desc' => 'What width container should the content be shown in?',
          'set_func' => "Config::select_one(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'PI_DIMENSIONS_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '304',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

    protected function format_values($value, $default, $round, $prepend, $append){
	  $output['prepend'] = '';
	  $output['value'] = $value;
	  $output['append'] = $default;
	  $decimals = 1;
	  $decimal = ',';
	  $separator = '.';
	  switch($default){
	    case 'mm':
		  $decimals = 0;
		  $decimal = ',';
		  $separator = '.';
		  if($round == '1' && $value >= 25){
			$output['value'] = $value / 10;
			$output['append'] = 'cm';
		  }
		break;
		case 'cm':
		  $decimal = ',';	
		  $separator = '.';			
		  if($round == '1'){
		    if($value >= 250){
              $output['value'] = $value / 100;
			  $output['append'] = 'm';
			}
		    if($value < 2.5){
			  $output['value'] = $value * 10;
			  $output['append'] = 'mm';
			}
		  }	  
		break;
		case 'm':
		  $decimals = 2;
		  $decimal = ',';
		  $separator = '.';	
          if($round == '1' && $value <= 2.5){
            $output['value'] = $value * 100;
            $output['append'] = 'cm';
		  }			
		break;
		case 'in':
		  $decimal = '.';
		  $separator = ',';
          if($round == '1' && $value >= 30){
            $output['value'] = $value / 12;
            $output['append'] = 'ft';
		  }			
		break;
		case 'ft':
		  $decimal = '.';
		  $separator = ',';	
          if($round == '1'){
            if($value <= 30){
			  $output['value'] = $value * 12;
			  $output['append'] = 'in';
		    }
			if($value > 9){
			  $output['value'] = $value / 3;
			  $output['append'] = 'yd';
			}
		  }			
		break;
		case 'yd':
		  $decimal = '.';
		  $separator = ',';
		  if($round == '1' && $value <= 9){
			$output['value'] = $value * 3;
			$output['append'] = 'ft';
		  }
		  break;
		default:
	      $output['prepend'] = $prepend;
	      $output['append'] = $append;		  
		break;
	  }

	return $output['prepend'] . ' ' . number_format($output['value'], $decimals, $decimal, $separator) . ' ' . $output['append'];
	}

	protected function recalculate($value, $default, $convert, $round){
	  $output['value'] = $value;
	  $output['append'] = $default;
	  
	  switch($convert){
		case 'in':
		  $output['append'] = 'in';
		  switch($default){
			case 'mm':
			  $output['value'] = $value / 25.4;
			break;
			case 'cm':
			  $output['value'] = $value / 2.54;			  
			break;
			case 'm':
			  $output['value'] = $value / 0.0254;			
			break;
			default:
			  $round = '1';
			break;
		  }
		break;
		case 'ft':
		  $output['append'] = 'ft';		
		  switch($default){
			case 'mm':
			  $output['value'] = $value / 304.8;
			break;
			case 'cm':
			  $output['value'] = $value / 30.48;
			break;
			case 'm':
			  $output['value'] = $value / 0.3048;
			break;
			default:
			  $round = '1';
			break;			
		  }		
		break;
		case 'yd':
		  $output['append'] = 'yd';		
		  switch($default){
			case 'mm':
			  $output['value'] = $value / 914.4;
			break;
			case 'cm':
			  $output['value'] = $value / 91.44;
			break;
			case 'm':
			  $output['value'] = $value / 0.9144;
			break;
			default:
			  $round = '1';
			break;			
		  }		
		break;
		case 'mm':
		  $output['append'] = 'mm';		
		  switch($default){
			case 'in':
			  $output['value'] = $value * 25.4;
			break;
			case 'ft':
			  $output['value'] = $value * 304.8;
			break;
			case 'yd':
			  $output['value'] = $value * 914.4;
			break;
			default:
			  $round = '1';
			break;			
		  }		
		break;
		case 'cm':
		  $output['append'] = 'cm';		
		  switch($default){
			case 'in':
			  $output['value'] = $value * 2.54;
			break;
			case 'ft':
			  $output['value'] = $value * 30.48;
			break;
			case 'yd':
			  $output['value'] = $value * 91.44;
			break;
			default:
			  $round = '1';
			break;			
		  }			
		break;
		case 'm':
		  $output['append'] = 'm';		
		  switch($default){
			case 'in':
			  $output['value'] = $value * 0.0254;
			break;
			case 'ft':
			  $output['value'] = $value * 0.3048;
			break;
			case 'yd':
			  $output['value'] = $value * 0.9144;
			break;
			default:
			  $round = '1';
			break;			
		  }			
		break;
		default:
		break;
	  }
	  
	  return $this->format_values($output['value'], $output['append'], $round, '', '');
	}

  }
