<?php


/*
* $Id: update.php
* $Loc: admin/updates/products_meassures
*
* Name: products_meassures
* Version: 2.0.0
* Release Date: 09/23/2022
* Author: Daniel @Kofod95
* 	 phoenixcart.org - Kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2022: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/

$update_config = [
	'description'		=> 'Allows setting up custom dimensions with custom default-scale and conversion. These can be added to products, and be shown on the product info page along with the products weight. Customers can change the scale, if conversion is given as an option, which will happen without page reload',
	'required_version'	=> '1.0.8.5',
	'max_version'		=> '1.0.9.0',
	'osc_required_version'	=> '',
	'osc_max_version'	=> '',
	'ignore_folders'	=> '',
	'supports_osc'		=> false,
	'supports_phoenix'		=> true,
	'update_version'	=> '2.0.0',
	'update_date'		=> '09/23/2022',
	'update_author'		=> 'Daniel @Kofod95',
	'update_all_php'	=> true,
	'randomize_zip_file'	=> false,
	'update_contact'	=> 'phoenixcart.org - Kofod95',
	'update_license'	=> 'Released under the GNU General Public License',
	'update_comments'	=> 'Copyright (c) 2022: Daniel - @Kofod95


  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.',
	'tasks'			=> 'install|remove',
];

$update_pre_install_actions = [
	[
		'type'		=> 'sql',
		'action'	=> 'install',
		'optional'	=> false,
		'items'		=> [
			'CREATE TABLE `dimensions` ( `dimensions_id` INT(11) NOT NULL AUTO_INCREMENT , `dimensions_default` VARCHAR(255) NOT NULL DEFAULT \'Other\' , `dimensions_converts_to` VARCHAR(255) NULL , `dimensions_round` TINYINT(1) NOT NULL , `dimensions_sort_order` INT(11) NULL , PRIMARY KEY (`dimensions_id`));CREATE TABLE `dimensions_info` ( `dimensions_id` INT(11) NOT NULL , `languages_id` INT(11) NOT NULL , `dimensions_name` VARCHAR(255) NULL , `dimensions_prepend` VARCHAR(255) NULL , `dimensions_append` VARCHAR(255) NULL , PRIMARY KEY (`dimensions_id`, `languages_id`));CREATE TABLE `dimensions_to_products` ( `dimensions_id` INT(11) NOT NULL , `products_id` INT(11) NOT NULL , `dimensions_value` FLOAT(11,4) NOT NULL , PRIMARY KEY (`dimensions_id`, `products_id`));',
		],
	],
];


$update_post_install_actions = [
];


$update_uninstall_actions = [
	[
		'type'		=> 'ajax',
		'action'	=> 'remove',
		'optional'	=> false,
		'items'		=> [
			'modules/pi/product_info/pi_meassures',
			'',
		],
	],
	[
		'type'		=> 'files_delete',
		'action'	=> 'remove',
		'optional'	=> false,
		'items'		=> [
			'/admin/dimensions.php',
			'/admin/includes/actions/dimensions/delete_confirm.php',
			'/admin/includes/actions/dimensions/infoboxes/default.php',
			'/admin/includes/actions/dimensions/infoboxes/delete.php',
			'/admin/includes/actions/dimensions/infoboxes/edit.php',
			'/admin/includes/actions/dimensions/infoboxes/new.php',
			'/admin/includes/actions/dimensions/insert.php',
			'/admin/includes/actions/dimensions/save.php',
			'/admin/includes/boxes/catalog_dimensions.php',
			'/admin/includes/languages/danish/dimensions.php',
			'/admin/includes/languages/danish/modules/boxes/catalog_dimensions.php',
			'/admin/includes/languages/english/dimensions.php',
			'/admin/includes/languages/english/modules/boxes/catalog_dimensions.php',
			'/includes/hooks/admin/catalog/dimensions.php',
			'/includes/languages/danish/hooks/admin/catalog/dimensions.php',
			'/includes/languages/danish/modules/pi/product_info/pi_dimensions.php',
			'/includes/languages/english/hooks/admin/catalog/dimensions.php',
			'/includes/languages/english/modules/pi/product_info/pi_dimensions.php',
			'/includes/modules/pi/product_info/pi_dimensions.php',
			'/includes/modules/pi/product_info/templates/tpl_pi_dimensions.php',
		],
	],
	[
		'type'		=> 'sql',
		'action'	=> 'remove',
		'optional'	=> true,
		'items'		=> [
			'DROP TABLE `dimensions`;DROP TABLE `dimensions_info`;DROP TABLE `dimensions_to_products`;',
		],
	],
];


?>